import {ROUTER_DEFINATION} from "./const"
let {KEY,METHOD,PATH,MIDDLEWARE,DATA,ERROR,TYPE,REQUESTBODY,ARGUMENT,CONTROLLER,DOMAIN,ENV_VERIABLE
,REQUESTHEADER,REQUESTPARAM,REQUESTQUERY,REQUEST,RESPONCE,NEXT,SEND,FUNCTION,PROPERY_NAME} =ROUTER_DEFINATION;
let reqArg:any=[];
let  controllerDefination:any=[]
let middleware:any=[];
export let RequestBody=(target: Object, propertyKey: string | symbol, parameterIndex: number)=>{
    reqArg[parameterIndex]={};
    reqArg[parameterIndex][KEY]=propertyKey;
    reqArg[parameterIndex][TYPE]=REQUESTBODY;
    reqArg[parameterIndex][PROPERY_NAME]=propertyKey;
}

export let RequestParam=(key)=>(target: Object |any, propertyKey: string | symbol, parameterIndex: number)=>{
    console.log( "target=>",JSON.stringify(target),target?.prototype)
    reqArg[parameterIndex]={};
    reqArg[parameterIndex][KEY]= key;
    reqArg[parameterIndex][TYPE]=REQUESTPARAM
}

export let RequestQuery=(key)=>(target: Object, propertyKey: string | symbol, parameterIndex: number)=>{
    reqArg[parameterIndex]={};
    reqArg[parameterIndex][KEY]= key;
    reqArg[parameterIndex][TYPE]=REQUESTQUERY;
}

export let RequestHeader=(target: Object, propertyKey: string | symbol, parameterIndex: number)=>{
    reqArg[parameterIndex]={};
    reqArg[parameterIndex][KEY]=null;
    reqArg[parameterIndex][TYPE]=REQUESTHEADER
}

export let Request=(target: Object, propertyKey: string | symbol, parameterIndex: number)=>{
    reqArg[parameterIndex]={};
    reqArg[parameterIndex][KEY]=null;
    reqArg[parameterIndex][TYPE]=REQUEST
}

export let Responce=(target: Object, propertyKey: string | symbol, parameterIndex: number)=>{
    reqArg[parameterIndex]={};
    reqArg[parameterIndex][KEY]=null;
    reqArg[parameterIndex][TYPE]=RESPONCE

}

export let Next=(err:any=null)=>(target: Object, propertyKey: string | symbol, parameterIndex: number)=>{
    reqArg[parameterIndex]={};
    reqArg[parameterIndex][KEY]=null;
    reqArg[parameterIndex][ERROR]=null
    reqArg[parameterIndex][TYPE]=NEXT
}

export let Send=(data:any)=>(target: Object, propertyKey: string | symbol, parameterIndex: number)=>{
    reqArg[parameterIndex]={};
    reqArg[parameterIndex][KEY]=null;
    reqArg[parameterIndex][ERROR]=null
    reqArg[parameterIndex][TYPE]=SEND
    reqArg[parameterIndex][DATA]=data
}


export function RequestMap1(method:string,path:string){
   return function(target: Object, propertyName: string | Symbol, descriptor: TypedPropertyDescriptor<Function>){
    //console.log(reqArg);
    let reqArgtemp= JSON.parse(JSON.stringify(reqArg))
    let tempFunStr=String(descriptor.value);
     descriptor.value=(req:any,res:any,next:any)=>{
        let tempFun:any=null;
        eval("tempFun="+tempFunStr);
        let mapArg=reqArgtemp.map((arg)=>{
                if(arg[TYPE]==REQUEST){
                    return req;
                }
                else if(arg[TYPE]==RESPONCE){
                    return res;
                }
                else if(arg[TYPE]==REQUESTBODY){
                    let obj=req.body;
                    if(arg[KEY])
                       return obj && obj[arg[KEY]]
                     return obj;
                }
                else if(arg[TYPE]==REQUESTPARAM){
                    let obj=req.params;
                    if(arg[KEY])
                       return obj && obj[arg[KEY]]
                    return obj;
                }
                else if(arg[TYPE]==REQUESTQUERY){
                    let obj=req.query;
                    if(arg[KEY])
                       return obj && obj[arg[KEY]]
                     return obj;
                }
                else if(arg[TYPE]==REQUESTHEADER){
                    let obj=req.headers;
                    if(arg[KEY])
                       return obj && obj[arg[KEY]]
                     return obj;
                }
                else if(arg[TYPE]==NEXT){
                    return next;
                }
                else if(arg[TYPE]==SEND){
                    return res.send;
                }
            })
            tempFun.apply(this,mapArg);
      }

      let reqMap={};
      reqMap[METHOD]=method;
      reqMap[PATH]=path;
      reqMap[FUNCTION]=descriptor.value
      reqMap[MIDDLEWARE]=middleware;
      controllerDefination.push(reqMap);
      reqArg=[];
      middleware=[];
      return descriptor;
}
}
export let Middleware1=(option=null)=>(target: any, propertyName: string, descriptor: PropertyDescriptor)=>{
    let reqArgtemp= JSON.parse(JSON.stringify(reqArg))
    let tempFunStr=String(descriptor.value);
     descriptor.value=(req:any,res:any,next:any)=>{
        let tempFun:any=null;
        eval("tempFun="+tempFunStr);
        let mapArg=reqArgtemp.map((arg)=>{
                if(arg[TYPE]==REQUEST){
                    return req;
                }
                else if(arg[TYPE]==RESPONCE){
                    return res;
                }
                else if(arg[TYPE]==REQUESTBODY){
                    let obj=req.body;
                    if(arg[KEY])
                       return obj && obj[arg[KEY]]
                     return obj;
                }
                else if(arg[TYPE]==REQUESTPARAM){
                    let obj=req.params;
                    if(arg[KEY])
                       return obj && obj[arg[KEY]]
                    return obj;
                }
                else if(arg[TYPE]==REQUESTQUERY){
                    let obj=req.query;
                    if(arg[KEY])
                       return obj && obj[arg[KEY]]
                     return obj;
                }
                else if(arg[TYPE]==REQUESTHEADER){
                    let obj=req.headers;
                    if(arg[KEY])
                       return obj && obj[arg[KEY]]
                     return obj;
                }
                else if(arg[TYPE]==NEXT){
                    return next;
                }
                else if(arg[TYPE]==SEND){
                    return res.send;
                }
            })
            tempFun.apply(this,mapArg);
      }

      let reqMap={};
    //   reqMap[METHOD]=null;
    //   reqMap[PATH]=null;
    //   reqMap[FUNCTION]=descriptor.value
    //   reqMap[MIDDLEWARE]=middleware.map((d)=>d);
    //   reqMap[ARGUMENT]=reqArg.map((d)=>d);
    //   controllerDefination.push(reqMap);
      reqArg=[];
      middleware=[];
      return descriptor;

}
export let AddMiddleware=(fun:Array<Function>)=>(target: any, propertyName: string, descriptor: TypedPropertyDescriptor<Function>)=>{
    fun.forEach((f)=>{
        console.log("midl ",String(f))
    })
    middleware=fun;
}

export let Controller=(property:{url?:string,domain?:string,env?:string})=>(target:Function)=>{
    target.prototype[CONTROLLER]=controllerDefination;
    target.prototype[PROPERY_NAME]=property.url || "";
    target.prototype[DOMAIN]=property.domain || (property.env && process.env[property.env]) || process.env.BACKEND || "" ;
    controllerDefination=[];
}





export function RequestMap(method:"get"|"post"|"put"|"delete",path) {
  return function (
    target: Object,
    key: string | symbol,
    descriptor: PropertyDescriptor
  ) {
    let reqArgtemp= JSON.parse(JSON.stringify(reqArg))
    const childFunction = descriptor.value;
    let serverReq = (req:any,res:any)=>{
        let mapArg=reqArgtemp.map((arg:any)=>{
                if(arg[TYPE]==REQUEST){
                    return req;
                }
                else if(arg[TYPE]==RESPONCE){
                    return res;
                }
                else if(arg[TYPE]==REQUESTBODY){
                    return req.body;
                }
                else if(arg[TYPE]==REQUESTPARAM){
                    let obj=req.params;
                    if(arg[KEY])
                       return obj && obj[arg[KEY]]
                    return obj;
                }
                else if(arg[TYPE]==REQUESTQUERY){
                    let obj=req.query;
                    if(arg[KEY])
                       return obj && obj[arg[KEY]]
                     return obj;
                }
                else if(arg[TYPE]==REQUESTHEADER){
                    return req.header;
                }
            })
            console.log("anotation arg=>",mapArg,reqArgtemp)
           let promiseReq= childFunction.apply(this,mapArg)
           if(promiseReq?.then){
              promiseReq.then((result)=>{
                res.send(result)
              })
           }
           else{
            res.send(promiseReq);
           }
            
      }
      let that=this;
      descriptor.value=(...arglist:any)=>{
        let reqBody={};
        let reqHeader={
            "content-type":"application/json; charset=utf-8"
        }
        console.log(target);
        let fullPath=target[DOMAIN]+ target[PROPERY_NAME]+path;
        let query:any=[];
        reqArgtemp.forEach((arg:any,i)=>{
             if(arg[TYPE]==REQUESTBODY){
              reqBody={...reqBody,...arglist[i]}   
             }
            else if(arg[TYPE]==REQUESTPARAM){
                fullPath=fullPath.replace(":"+arg[KEY],arglist[i])
            }
            else if(arg[TYPE]==REQUESTQUERY){
                query.push(arg[KEY]+"="+arglist[i])
            }
            else if(arg[TYPE]==REQUESTHEADER){
                reqHeader={...reqHeader,...arglist[i]}
            }
        })
        if(query.length>0){
            fullPath=fullPath+"?"+query.join("&");
        }
       return new Promise((resolve,reject)=>{
        let optionData={}
        if(method!=="get"){
           optionData= {
                method:method,
                body:JSON.stringify(reqBody),
                headers:reqHeader
             }
        }
        else{
            optionData= {
                method:method,
                headers:reqHeader
             }
        }
         fetch(fullPath,optionData)
         .then((res)=>res.json())
         .then((result)=>{
            resolve(result)
         })
         .catch((err)=>{
            reject(err);
         })
       })
      }
      let reqMap={};
      reqMap[METHOD]=method;
      reqMap[PATH]=path;
      reqMap[FUNCTION]=serverReq;
      reqMap[MIDDLEWARE]=middleware;
      controllerDefination.push(reqMap);
      reqArg=[];
      middleware=[];
    return descriptor;
  };
}



export function Middleware() {
    return function (
      target: Object,
      key: string | symbol,
      descriptor: PropertyDescriptor
    ) {
      let reqArgtemp= JSON.parse(JSON.stringify(reqArg))
      const childFunction = descriptor.value;
      descriptor.value = (req:any,res:any,next:any)=>{
          let mapArg=reqArgtemp.map((arg)=>{
                  if(arg[TYPE]==REQUEST){
                      return req;
                  }
                  else if(arg[TYPE]==RESPONCE){
                      return res;
                  }
                  else if(arg[TYPE]==REQUESTBODY){
                      let obj=req.body;
                      if(arg[KEY])
                         return obj && obj[arg[KEY]]
                       return obj;
                  }
                  else if(arg[TYPE]==REQUESTPARAM){
                      let obj=req.params;
                      if(arg[KEY])
                         return obj && obj[arg[KEY]]
                      return obj;
                  }
                  else if(arg[TYPE]==REQUESTQUERY){
                      let obj=req.query;
                      if(arg[KEY])
                         return obj && obj[arg[KEY]]
                       return obj;
                  }
                  else if(arg[TYPE]==REQUESTHEADER){
                      let obj=req.headers;
                      if(arg[KEY])
                         return obj && obj[arg[KEY]]
                       return obj;
                  }
                  else if(arg[TYPE]==NEXT){
                      return next;
                  }
                  else if(arg[TYPE]==SEND){
                      return res.send;
                  }
              })
              childFunction.apply(this,mapArg);
        }
        let reqMap={};
        // reqMap[METHOD]=method;
        // reqMap[PATH]=path;
        // reqMap[FUNCTION]=descriptor.value
        // reqMap[MIDDLEWARE]=middleware;
        // controllerDefination.push(reqMap);
        reqArg=[];
        middleware=[];
      return descriptor;
    };
  }

export class Server{
   static app; 
   static setApp(app){
    this.app=app;
   }
  static addController(controller){
    controller[CONTROLLER].forEach((obj) => {
        let endpoint=controller[PROPERY_NAME]+ obj[PATH]
        let middleware=obj[MIDDLEWARE]
        let fun=obj[FUNCTION]
        let method=obj[METHOD]
        let argument:any=[];
        //console.log("propperty",String(fun))
        if(endpoint)
            argument.push(endpoint)
        //console.log("endPoint==>",endpoint)
        middleware.forEach((funMid) => {
            argument.push(funMid);
        });
        argument.push(fun)
        if(method==="get"){
            this.app.get.apply(this.app,argument);
        }
        else if(method==="post"){
            this.app.post.apply(this.app,argument);
        }
        else if(method==="put"){
            this.app.put.apply(this.app,argument);
        }
        else if(method==="use"){
            this.app.use.apply(null,argument);
        } 
    });
  }
}